#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cstdlib>

int main(int argc, char *argv[]) {

	typedef long long t_long;

	int dim = atol(argv[1]), num = atoi(argv[2]), max = atoi(argv[3]);
	int tid = atoi(argv[4]), rnd = atoi(argv[5]);
	srand(rnd);

	std::vector<std::vector<t_long>> LEN(dim + 1);

	//Генерируем размерности массива
	switch (tid) {
	case 4:
	case 3:
	case 2:
		for (int i = 0; i < dim; ++ i) { LEN[i].resize(max, 0); }
		break;
	case 1:
		for (int i = 0; i < dim; ++ i) {
			LEN[i].resize((3 * (i / 3) + 1) * (max / dim), 0);
		}
		break;
	case 0:
		for (int i = 0; i < dim; ++ i) {
			LEN[i].resize((i + 1) * (max / dim), 0);
		}
		break;
	}
	LEN[dim].resize(LEN[dim - 1].size(), 0);

	//Заполняем вспомогательный массив, хранящий информацию о размерностях
	t_long sum = 0;
	for (int j = 0; j < LEN[dim - 1].size(); ++ j) {
		sum += (LEN[dim - 1][j] = 1);
	}
	for (int i = dim - 2; i >= 0; -- i) {
		t_long s1 = 0, s2 = 0;
		for (int j = 0; j < LEN[i].size(); ++ j) {
			LEN[i][j] = sum - s2;
			s2 += LEN[i + 1][j];
			s1 += LEN[i][j];
		}
		sum = s1;
	}
	for (int i = 0; i < dim; ++ i) {
		t_long s1 = 0, s2 = 0;
		for (int j = 0; j < LEN[i].size(); ++ j) {
			s1 = LEN[i][j] + s2;
			LEN[i][j] = s2;
			s2 = s1;
		}
	}
	t_long lim = LEN[0].back();

	//Генерируем запросы
	std::vector<std::vector<int>> F; std::vector<t_long> B;
	switch (tid) {
	case 4:
		for (int i = 0; i < num; ++ i) B.push_back(lim - i);
		break;
	case 3:
		for (int i = 0; i < num; ++ i) {
			F.push_back(std::vector<int> (dim));
			t_long pos = lim - i;
			for (int k = 0; k < dim; ++ k) {
				int l = std::upper_bound(
				    LEN[k].begin(), LEN[k].end(), pos
				) - LEN[k].begin() - 1;
				pos -= LEN[k][l] - LEN[k + 1][l];
				F.back()[k] = l;
			}
		}
		break;
	case 2:
	case 1:
	case 0:
		for (int i = 0; i < num; ++ i)
		if (rand() % 2) {
			F.push_back(std::vector<int> (dim));
			for (int k = 0; k < dim; ++ k) {
				F.back()[k] = rand() % LEN[k].size();
			}
		}
		else {
			B.push_back(
			t_long(
			lim * double(rand()) / RAND_MAX)
			);
		}
		break;
	}

	std::random_shuffle(F.begin(), F.end());
	std::random_shuffle(B.begin(), B.end());

	std::ofstream out("input.txt");
	out << dim << "\n";
	for (int i = 0; i < dim; ++ i) { out << LEN[i].size() << " "; }
	out << "\n" << num;
	out << "\n";
	for (int i = 0; i < num; ++ i) {
		if (((rand() % 2) && !F.empty()) || B.empty()) {
			out << "f";
			for (auto f: F.back()) { out << " " << f; }
			F.pop_back();
		}
		else {
			out << "b " << B.back();
			B.pop_back();
		}
		out << "\n";
	}

	return 0;
}
